;program for sending av ascii kode 110 Bps til 57600 Bps
;Programmet og ascii generatoren er utviklet av Sondre Danielsen

	LIST    P=16C84;f=inhx8m
	
_CP_OFF		equ	H'3FFF'			;code protect off
_PWRTE_ON	equ	H'3FFF' 		;Power on timer on
_WDT_OFF	equ	H'3FFB'			;watch dog timer off
_XT_OSC		equ	H'3FFD'			;crystal oscillator
__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
	
xx	equ	0E	
same	equ	1
count1  equ     0C      ; wait counter ls digit file register C
count2  equ	0D	; wait counter ms digit file register D
porta   equ     05      ; port b I/O register f6
portb	equ	06	; port a I/O register f5
trisb	equ	086h
trisa	equ 	85h
status	equ	03h
var1	equ	10	;variabel til byte for sending
var2	equ	11	;variabel til byte for mottaking
var3	equ 	12	;variabel til dec i tx og rx rutine
var4	equ	13	;variabel til twait 
var5	equ	14	;variabel til Bps hastighet
var6	equ	15	;variabel til twait
var7	equ	16	;variabel til twait
var8	equ	17	;variabel til twait
var9	equ	18	;variabel til twait
var10	equ	19 	;variabel til auto
;
;
init   
	clrf	portb
	bsf	status,5
	movlw	B'11111111'	;setter portb,01234567 til inng.og  til utg.
	movwf	trisb
	movlw	B'00011110'	;setter poera,1234 til inng og 0 til utg
	movwf	trisa
	bcf	status,5
	movlw   0
	movwf   portb   

start	call	wait2

; --------------------------
;Leser Bps velger
; --------------------------
st1	btfsc	porta,2
	goto	auto
	call	twait
	clrf	var10
	clrf	var6
	btfsc	portb,7		;57600	Bps
	goto	b57
	btfsc	portb,6		;38400	Bps
	goto	b38
	btfsc	portb,5		;19200	Bps
	goto	b19
	btfsc	portb,4		;9600	Bps
	goto	b96
	btfsc	portb,3		;4800	Bps
	goto	b48
	btfsc	portb,2		;2400	Bps
	goto	b24
	btfsc	portb,1		;1200	Bps
	goto	b12
        btfsc	portb,0		;300    Bps
	goto	b30
	goto	b11		;110	Bps

;-----------------------------------------------
;automatisk variabel bit hastighet
;-----------------------------------------------
auto	bsf	var10,0
	call	b11
	call	wait
	call	wait2
	call	b30
	call	wait
	call	wait2
	call	b12
	call	wait
	call	wait2
	call	b24
	call	wait
	call	wait2
	call	b48
	call	wait
	call	wait2
	call	b96
	call	wait
	call	wait2
	call	b19
	call	wait
	call	wait2
	call	b38
	call	wait
	call	wait2
	call	b57
	call	wait
	call	wait2
	goto	start
;-----------------------------------------------
;rutiner for hastigehter
;-----------------------------------------------
b57	clrf	var6			;57600 Bps
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01010110'		;5
	movwf	var1
	call	tx	
	movlw	B'01110110'		;7
	movwf	var1
	call	tx	
	movlw	B'00110110'		;6
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut

b38	clrf	var6			;38400 Bps
	bsf	var6,0
	movlw	.2
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01100110'		;3
	movwf	var1
	call	tx	
	movlw	B'00001110'		;8
	movwf	var1
	call	tx	
	movlw	B'00010110'		;4
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut

b19	clrf	var6			;19200 	bps
	bsf	var6,0
	movlw	.11
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01000110'		;1
	movwf	var1
	call	tx	
	movlw	B'01001110'		;9
	movwf	var1
	call	tx	
	movlw	B'00100110'		;2
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut

b96	clrf	var6			;9600 Bps
	bsf	var6,0
	movlw	.30
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01001110'		;9
	movwf	var1
	call	tx	
	movlw	B'00110110'		;6
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut


b48	clrf	var6			;4800 Bps
	bsf	var6,0
	movlw	.64
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'00010110'		;4
	movwf	var1
	call	tx	
	movlw	B'00001110'		;8
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut


b24	clrf	var6			;2400 Bps
	bsf	var6,0
	movlw	.130
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'00100110'		;2
	movwf	var1
	call	tx	
	movlw	B'00010110'		;4
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut


b12	clrf	var6			;1200 Bps
	bsf	var6,0
	bsf	var6,1
	movlw	.3
	movwf	var8
	movlw	.29
	movwf	var9
	movlw	.180
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01000110'		;1
	movwf	var1
	call	tx	
	movlw	B'00100110'		;2
	movwf	var1
	call	tx	
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut

b30	clrf	var6			;300 Bps
	bsf	var6,0
	bsf	var6,1
	movlw	.10
	movwf	var8
	movlw	.100
	movwf	var9
	movlw	.60	;74
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01100110'		;3
	movwf	var1
	call	tx		
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
	goto	aut


b11	clrf	var6			;110 Bps
	bsf	var6,0
	bsf	var6,1
	movlw	.28
	movwf	var8
	movlw	.100
	movwf	var9
	movlw	.30
	movwf	var5
	btfsc	porta,1
	goto	aa
	call	test
	movlw	B'01000110'		;1
	movwf	var1
	call	tx		
	movlw	B'01000110'		;1
	movwf	var1
	call	tx
	movlw	B'00000110'		;0
	movwf	var1
	call	tx
	call	bps
aut	btfsc	var10,0
	return
	goto	start

;---------------------------------------------
;sender aaaaaaaaaaaaaaa
;---------------------------------------------
aa	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
 	movlw	B'01000011'		;a
	movwf	var1
	call	tx
	goto	aut
;----------------------------------------------
;sender Bps!!!
;----------------------------------------------
bps	movlw	B'00000010'		;space
	movwf	var1
	call	tx	
	movlw	B'00100001'		;B
	movwf	var1
	call	tx	
	movlw	B'00000111'		;p
	movwf	var1
	call	tx	
	movlw	B'01100111'		;s
	movwf	var1
	call	tx	
	movlw	B'01000010'		;!
	movwf	var1
	call	tx
	movlw	B'01000010'		;!
	movwf	var1
	call	tx
	movlw	B'01000010'		;!
	movwf	var1
	call	tx
	movlw	B'00000010'		;space
	return



;-----------------------------------------------
; sender Dette er en test
;-----------------------------------------------
test	
	bsf	portb,3
	movlw	B'00000010'		;space
	movwf	var1
	call	tx	
	movlw	B'00010001'		;D
	movwf	var1
	call	tx	
	movlw	B'001010011'		;e
	movwf	var1
	call	tx
	movlw	B'00010111'		;t
	movwf	var1
	call	tx
	movlw	B'00010111'		;t
	movwf	var1
	call	tx	
	movlw	B'01010011'		;e
	movwf	var1
	call	tx	
	movlw	B'00000010'		;space
	movwf	var1
	call	tx	
	movlw	B'01010011'		;e
	movwf	var1
	call	tx	
	movlw	B'00100111'		;r
	movwf	var1
	call	tx
	movlw	B'00000010'		;space
	movwf	var1
	call	tx
	movlw	B'01010011'		;e
	movwf	var1
	call	tx	
	movlw	B'00111011'		;n
	movwf	var1
	call	tx	
	movlw	B'00000010'		;space
	movwf	var1
	call	tx	
	movlw	B'00010111'		;t
	movwf	var1
	call	tx	
	movlw	B'01010011'		;e
	movwf	var1
	call	tx
	movlw	B'01100111'		;s
	movwf	var1
	call	tx
	movlw	B'00010111'		;t
	movwf	var1
	call	tx	
	movlw	B'00000010'		;space
	movwf	var1
	call	tx	
	return



; ------------------------------------------
;sending av tegn
; ------------------------------------------
tx	movlw	.9
	movwf	var3
	bcf 	porta,0
tx1	call	twait
	decfsz	var3
	goto	tx2
	goto	tx3
tx2	btfsc	var1,7
	bcf	porta,0
	btfss	var1,7
	bsf	porta,0
	rlf	var1,1
	goto	tx1
tx3	bsf	porta,0
	call	twait
	call	twait
	return







; ----------------------------
; wait subrutine for sending
; ----------------------------
twait	btfsc	var6,0		;57600	Bps
	goto	t1
	nop
	nop
	return

t1      movfw	var5		;38400	Bps		
	movwf	var4		
tw1	decfsz	var4		
	goto	tw1		
	btfss	var6,1	
	return			

	movfw	var8		;1200	Bps til 110 Bps
	movwf	var4
tw2	movfw	var9
	movwf	var7
tw3	decfsz	var7
	goto	tw3
	decfsz	var4
	goto	tw2
	return
;-----------------------------
;wait2
;-----------------------------
wait2	btfss	porta,3
	return
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	return

; ----------------------------
; wait subroutine 
; ----------------------------
wait    
	movlw   .200	        ; load count1 with decimal 200
	movwf   count1
d1	movlw   .200		; load count2 with decimal 200
	movwf   count2	
				; shorten these for the simulator
	
d2	decfsz  count2,same	; decrement and skip next line if zero
	goto 	d2		; if not zero		
	decfsz  count1		; decrement count1 if count2 is zero
	goto 	d1		; do inside loop again if count2 nz
	retlw 	00


END